=== meos/src/CMakeLists.txt ===
add_subdirectory(general)
add_subdirectory(point)
if(NPOINT)
  add_subdirectory(npoint)
endif()
