=== debian/changelog ===
mobilitydb (1.1.1-1.pgdg20.04+1) focal-pgdg; urgency=medium

  * Rebuild for focal-pgdg.
  * Changes applied by generate-pgdg-source:
    + Using debhelper 12.

 -- PostgreSQL on Debian and Ubuntu <pgsql-pkg-debian@lists.postgresql.org>  Tue, 07 May 2024 17:00:40 +0200

mobilitydb (1.1.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1037101)

 -- Bradford D. Boyle <bradford.d.boyle@gmail.com>  Tue, 07 May 2024 17:00:40 +0200
