=== debian/control ===
Source: mobilitydb
Section: database
Priority: optional
Maintainer: Debian PostgreSQL Maintainers <team+postgresql@tracker.debian.org>
Uploaders:
 Bradford D. Boyle <bradford.d.boyle@gmail.com>,
Build-Depends:
 debhelper (>= 12),
 postgresql-all (>= 256~),
 cmake,
 libgeos-dev,
 libgsl-dev,
 libjson-c-dev,
 libproj-dev,
 postgresql-12-postgis-3, postgresql-13-postgis-3, postgresql-14-postgis-3, postgresql-15-postgis-3, postgresql-16-postgis-3,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://mobilitydb.com/
Vcs-Browser: https://salsa.debian.org/postgresql/MobilityDB
Vcs-Git: https://salsa.debian.org/postgresql/MobilityDB.git

Package: postgresql-12-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-12-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-13-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-13-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-14-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-14-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-15-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-15-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.

Package: postgresql-16-mobilitydb
Architecture: any
Depends:
 ${misc:Depends},
 ${postgresql:Depends},
 ${shlibs:Depends},
 postgresql-16-postgis-3,
Description: Open source geospatial trajectory data management & analysis platform
 MobilityDB is a database management system for moving object geospatial
 trajectories, such as GPS traces. It adds support for temporal and
 spatio-temporal objects to the PostgreSQL database and its spatial extension
 PostGIS.
