=== debian/tests/control ===
Depends:
 cmake,
 g++,
 libgeos-dev,
 libgsl-dev,
 libjson-c-dev,
 libproj-dev,
 make,
 postgresql-16-postgis-3,
 xz-utils,
 @,
Tests: installcheck
Restrictions: allow-stderr
